// ***********************************************************************
// **** C version of Kleinian script by Luca GN @ fractalforums, ***
// **** transcript of (see under) ***
// ***********************************************************************
#include "utility_MATH.cpp" // include this always 1st
#include "utility_DIFS.cpp"

void __attribute__((fastcall)) __main(void);
void wrap3D(double* x0, double* y0, double* z0,
double xa, double ya, double za,
double xs, double ys, double zs);

void wrap2D(double* x0, double* y0,
double xa, double ya,
double xs, double ys);

void TransA(double* xz, double* yz, double* zz, double* DF, double a, double b);
void TransAInv(double* xz, double* yz, double* zz, double* DF, double a, double b);
void TransA_Aex(double* xz, double* yz, double* zz, double* DF, double a, double b, double Aexion);
void TransAInv_Aex(double* xz, double* yz, double* zz, double* DF, double a, double b, double Aexion);

/*
// ***********************************************************************
// **** Original fragmentarium script by Jos & Knighty begins here: ***
// ***********************************************************************
#group Kleinian_test
uniform int Box_Iterations;  slider[1,50,100]
//Trace of the transformation a
uniform float KleinR;  slider[1.8,2.0,2.0]
uniform float KleinI;  slider[-0.2,0.0,0.2]
//To really give a kleinian group they must be of the form cos(PI/n) if <1 and any value if >=1
uniform float box_size_z;  slider[0.0,0.5,1.0]
uniform float box_size_x;  slider[0.0,0.5,1.0]
//WIP: Help get better DE?
uniform int Final_Iterations;  slider[0,5,20]
//Want do show the balls
uniform bool ShowBalls; checkbox[true]
//4 generators or 3? apply y translation
uniform bool FourGen; checkbox[false]
//The DE is wilde. It needs some clamping
uniform float Clamp_y;  slider[0.01,1.0,10.0]
uniform float Clamp_DF;    slider[0.0,1.0,10.0]

#group SphInv

//Want do do an inversion
uniform bool DoInversion; checkbox[false]
//Inversion center
uniform vec3 InvCenter; slider[(-1,-1,-1),(0,0,0),(1,1,1)]
//Inversion radius squared
uniform float InvRadius;  slider[0.01,1,2]
//Recenter
uniform vec3 ReCenter; slider[(-5,-5,-5),(0,0,0),(5,5,5)]

float dot2(vec3 z){ return dot(z,z);}

vec3 wrap(vec3 x, vec3 a, vec3 s){
	x -= s; 
	return (x-a*floor(x/a)) + s;
}

vec2 wrap(vec2 x, vec2 a, vec2 s){
	x -= s; 
	return (x-a*floor(x/a)) + s;
}

void TransA(inout vec3 z, inout float DF, float a, float b){
	float iR = 1. / dot2(z);
	z *= -iR;
	z.x = -b - z.x; z.y = a + z.y; 
	DF *= iR;//max(1.,iR);
}

void TransAInv(inout vec3 z, inout float DF, float a, float b){
	float iR = 1. / dot2(z + vec3(b,-a,0.));
	z.x += b; z.y = a - z.y; 
	z *= iR;
	DF *= iR;//max(1.,iR);
}

float  JosKleinian(vec3 z)
{
	vec3 lz=z+vec3(1.), llz=z+vec3(-1.);
	float DE=1e10;
	float DF = 1.0;
	float a = KleinR, b = KleinI;
	float f = sign(b) ;     
	for (int i = 0; i < Box_Iterations ; i++) 
	{
		//if(z.y<0. || z.y>a) break;
		
		z.x=z.x+b/a*z.y;
		if (FourGen)
			z = wrap(z, vec3(2. * box_size_x, a, 2. * box_size_z), vec3(- box_size_x, 0., - box_size_z));
		else
			z.xz = wrap(z.xz, vec2(2. * box_size_x, 2. * box_size_z), vec2(- box_size_x, - box_size_z));
		z.x=z.x-b/a*z.y;

		//If above the separation line, rotate by 180 about (-b/2, a/2)
		if  (z.y >= a * (0.5 +  f * 0.25 * sign(z.x + b * 0.5)* (1. - exp( - 3.2 * abs(z.x + b * 0.5)))))	
			z = vec3(-b, a, 0.) - z;//
			//z.xy = vec2(-b, a) - z.xy;//
		
		orbitTrap = min(orbitTrap, abs(vec4(z,dot(z,z))));//For colouring

		//Apply transformation a
		TransA(z, DF, a, b);
		
		//If the iterated points enters a 2-cycle , bail out.
		if(dot2(z-llz) < 1e-12) {
#if 0
			orbitTrap =vec4(1./float(i),0.,0.,0.);
#endif
			break;
		}
		//Store prvious iterates
		llz=lz; lz=z;
	}
	
	//WIP: Push the iterated point left or right depending on the sign of KleinI
	for (int i=0;i<Final_Iterations;i++){
		float y = ShowBalls ? min(z.y, a-z.y) : z.y;
		DE=min(DE,min(y,Clamp_y)/max(DF,Clamp_DF));
		TransA(z, DF, a, b);
	}
	float y = ShowBalls ? min(z.y, a-z.y) : z.y;
	DE=min(DE,min(y,Clamp_y)/max(DF,Clamp_DF));

	return DE;
}
*/

// ULTRASLIM since Jessie said Mb3D prepares everything for us already
// We just use those lame macros it should be fine I hope? duh
void __attribute__((fastcall)) __main(void) {
	double x,y,z;
	//vec3 lz=z+vec3(1.), llz=z+vec3(-1.);
	double DF = load1();
	x=loadX(); y=loadY(); z=loadZ();
	double lzx = x+DF; double lzy = y+DF; double lzz = z+DF;
	double llzx = x-DF; double llzy = y-DF; double llzz = z-DF;
	double DE = loadNthDoubleCns(0,0);
	double d2;
	double oC = DE;
	double a, b, AexJ;
	//double bdiva = (fabs(b)>loadNthDoubleCns(1,0))?b/a:load1();
	double bdiva, distJosfix;
	int Box_Iterations = loadNthIntVar(0,6*szof1dbl);
	int Final_Iterations = loadNthIntVar(1,6*szof1dbl);
	char SpI = (loadNthIntVar(2,6*szof1dbl))&4;
	char M3D = (loadNthIntVar(2,6*szof1dbl))&1; // 3d mode
	char showballs = (loadNthIntVar(2,6*szof1dbl))&2;
	showballs = (showballs == 0);
	// new options:
	char boxfolds = (loadNthIntVar(2,6*szof1dbl))&8;
	char sepline = (loadNthIntVar(2,6*szof1dbl))&16;
	char FMx = (loadNthIntVar(2,6*szof1dbl))&32;
	char FMz = (loadNthIntVar(2,6*szof1dbl))&64;
	// --------
	char ABS2x = (loadNthIntVar(2,6*szof1dbl))&128;
	char ABS2z = (loadNthIntVar(2,6*szof1dbl))&256;
	char enabaexj = (fabs(loadNthDoubleVar(9,3*szof1int)) < loadNthDoubleCns(3,0));
	
	double bsx = loadNthDoubleVar(2,0);
	double bsz = loadNthDoubleVar(3,0);
	double bsx2 = bsx*loadNthDoubleCns(5,0);
	double bsz2 = bsz*loadNthDoubleCns(5,0);
	int i;

	if (Box_Iterations>100) Box_Iterations = 100;
	if (Final_Iterations>20) Final_Iterations = 20;

    //Box_Iterations = 30; Final_Iterations = 4;
    a = loadNthDoubleVar(0,0); b = loadNthDoubleVar(1,0);
    AexJ = loadNthDoubleVar(10,3*szof1int);
    // bdiva = (b/a);
	WORD oldcw=fegr_floor(); // wrap() works ok
	// f = sig0p(b)*sig0p(AexJ)*loadNthDoubleCns(3,0); // f * 0.25
	distJosfix = sqrt(b*b+AexJ*AexJ);
	if (distJosfix>loadNthDoubleCns(9,0)) distJosfix = recip(distJosfix);
	
	// vars:
	// 0 = dbl a; 1 = dbl b; 2 = dbl box_size_x; 3 = dbl box_size_y; 
	// 4 = dbl clampY; 5 = dbl clampDF; 
	// 6+off(3int) = iCx 7+off(3int) = iCx 8+off(3int) = iCx
	// 0+off(6dbl) = int Box_Iterations; 
	// 1+off(6dbl) = int Final_Iterations; 
	
    if (SpI) {
        //z=z-InvCenter;
        x = x - loadNthDoubleVar(6,3*szof1int);
        y = y - loadNthDoubleVar(7,3*szof1int);
        z = z - loadNthDoubleVar(8,3*szof1int);
        double iR;
        if (enabaexj)
			 iR = load1(); 
		else iR = loadNthDoubleVar(9,3*szof1int);
		iR *= iR;
		d2 = length2(x,y,z);
		iR = iR/d2;
		x = x*iR + loadNthDoubleVar(6,3*szof1int);
        y = y*iR + loadNthDoubleVar(7,3*szof1int);
        z = z*iR + loadNthDoubleVar(8,3*szof1int);
    }
	
	// bdiva = loadzero();
	for (i = 0; i < Box_Iterations ; i++) 
	{
		double qR, x00;
		int ipx, ipz;
			
		//x += bdiva*y;
		donothing();
		if (FMx) {
			x += bsx*loadNthDoubleCns(2,0);
			x = fabs(x);
			x += bsx*loadNthDoubleCns(2,0);
		} else x += bsx;
		if (FMz) {
			z += bsz*loadNthDoubleCns(2,0);
			z = fabs(z);
			z += bsz*loadNthDoubleCns(2,0);
		} else z += bsz;
		ipx = storeint(x/bsx2);
		x -= bsx2*((double)ipx)+bsx;
		ipz = storeint(z/bsz2);
		z -= bsz2*((double)ipz)+bsz;
		

		if (M3D) {
			y += -a*(storeint(y/a));
		}
		
		if (boxfolds!= 0) {
			if ((ipx & 1) !=0 ) {
				x = -x;
			}
			if ((ipz & 1) !=0 ) {
				z = -z;
			}
		}
		//x -= bdiva*y;
		donothing();
	
		//If above the separation line, rotate by 180 about (-b/2, a/2)
		// if  (z.y >= a * (0.5 +  f * 0.25 * sign(z.x + b * 0.5)* (1. - exp( - 3.2 * abs(z.x + b * 0.5)))))

		// Jos' rotated separation line for Aexion mod! THANKS JOS!
		x00 = ( b * (x + b * loadNthDoubleCns(2,0))
		-AexJ*(z + AexJ * loadNthDoubleCns(2,0)) ) * distJosfix;
		// old separation line:
		// double x00 = x + b * loadNthDoubleCns(2,0);
		x00 = sign(x00) * (load1() - exp( loadNthDoubleCns(4,0) * fabs(x00) ) ) ;
		x00 =  a * (loadNthDoubleCns(2,0) +  loadNthDoubleCns(3,0) * x00);
		if (sepline== 0) {
			if  (y > x00 ) 
			{
				//z = vec3(-b, a, 0.) - z;
				// x = -b - x; y = a - y; z = -z ;original
				x = -b - x; y = a - y;
				z = AexJ - z; // Pupukuusikko mod THANKS
				//z.xy = vec2(-b, a) - z.xy; // commented out in Jos orig src
			}	
		} else {
			x00 -= y;
			x00 -= a * loadNthDoubleCns(1,0);
			if  (x00 < 0) break;
		}	
		
		if (ABS2x) {
			x = fabs(x);
		}
		if (ABS2z) {
			z = fabs(z);
		}
		//Apply transformation a (Orig)
		// TransA(&x,&y,&z, &DF, a, b);
		//Apply transformation a + add Aex to z
		// TransA_Aex(&x,&y,&z, &DF, a, b, AexJ);
		double jx = x*x - y*y + loadNthDoubleVar(4,0);
		double jy = y*x; 
		jy += jy + loadNthDoubleVar(5,0);
		
		qR = length2(x,y,z); qR = -recip(qR);
		//z *= -qR;
		x *= qR; y *= qR; z *= qR; 
		x = -b - x; y = a + y; z = AexJ - z; 
		DF *= -qR;//max(1.,qR);
		if (enabaexj) {
			x += jx*loadNthDoubleVar(9,3*szof1int); y += jy*loadNthDoubleVar(9,3*szof1int);
		}
		
		/*
			//For colouring
			double oCn = fabs(fabs(y)-fabs(x)-fabs(z));
			oC = min(oC, oCn);
		*/

		
		//If the iterated points enters a 2-cycle , bail out.
		if ( length2(x-llzx,y-llzy,z-llzz) < loadNthDoubleCns(9,0) ) 
		{
			break;
		}
		//Store prvious iterates
		llzx = lzx; llzy = lzy; llzz = lzz;
		lzx = x; lzy = y; lzz = z;
	}
	bsx = loadNthDoubleVar(11,3*szof1int);
	saveOTColor( (loadNthDoubleCns(6,0)-bsx)*lzy / ( bsx*sqrt((double)i)+loadNthDoubleCns(6,0)) );
	
	bsx = load1(); // loadNthDoubleVar(4,0); // clampy
	bsz = load1(); // loadNthDoubleVar(5,0); // clampdf
	//WIP: Push the iterated point left or right depending on the sign of KleinI
	i = 0;
	do {
		double iR = y;
	    if (showballs) iR = min(iR, a-iR); // Show balls (Strongly reccomended! Really! :D )
		DE=min(DE,min(iR,bsx)/max(DF,bsz));
		if (i>=Final_Iterations) break;
		//Apply inv-transformation a (Orig)
		// TransAInv(&x,&y,&z, &DF, a, b);
		//Apply inv-transformation a + add Aex to z
		// TransAInv_Aex(&x,&y,&z, &DF, a, b, AexJ);
			
		x = +b + x; y = a - y;
		z = -AexJ + z; // ? wut
		iR = recip(length2(x,y,z));
		x *= iR; y *= iR; z *= iR; 
		DF *= iR;//max(1.,iR);
		i++;
	} while (1);
	
    if (SpI) { // fixde finale sphereinv
        double iR;
        if (enabaexj)
			 iR = load1(); 
		else iR = loadNthDoubleVar(9,3*szof1int);
        DE=DE*d2/(iR+sqrt(d2)*DE);
    }
    
	fesetround(oldcw); // do this right before returning
	saveDE (DE);
/*
cns; loadNthDoubleCns(n,0);

0 = 1e10
1 = 1e-5
2 = 0.5
3 = 0.25
4 = -3.2
5 = 2.
6 = 1.5
7 = 0.5773502
---------
*/
}

// all forced inline because the compiler likes to mess up

INLI2 void wrap3D(double* x0, double* y0, double* z0,
double xa, double ya, double za,
double xs, double ys, double zs)
{
	// x -= s; 
	*x0 -= xs; *y0 -= ys; *z0 -= zs;
	// return (x-a*floor(x/a)) + s;
	*x0 += xs-xa*storeint(*x0/xa);
	*y0 += ys-ya*storeint(*y0/ya);
	*z0 += zs-za*storeint(*z0/za);
}

INLI2 void wrap2D(double* x0, double* y0,
double xa, double ya,
double xs, double ys)
{
	// x -= s; 
	*x0 -= xs; *y0 -= ys;
	// return (x-a*floor(x/a)) + s;
	//*x0 += xs-xa*storeint(*x0/xa);
	int bop = storeint(*y0/ya); if (bop&1) *x0 -= xa*loadNthDoubleCns(2,0);
	*y0 += ys-ya*((double)bop);
	*x0 += xs-xa*storeint(*x0/xa);
}

/*
INLI2 void TransA(double* xz, double* yz, double* zz, double* DF, double a, double b){
	double iR = recip(length2(*xz,*yz,*zz)); iR = -iR;
	//z *= -iR;
	*xz *= iR; *yz *= iR; *zz *= iR;
	*xz = -b - *xz; *yz = a + *yz; 
	*DF *= -iR;//max(1.,iR);
}

INLI2 void TransAInv(double* xz, double* yz, double* zz, double* DF, double a, double b){
	double iR;
	*xz = +b + *xz; *yz = a - *yz; 
	iR = recip(length2(*xz,*yz,*zz));
	*xz *= iR; *yz *= iR; *zz *= iR;

	*DF *= iR;//max(1.,iR);
}
*/
void TransA_Aex(double* xz, double* yz, double* zz, double* DF, double a, double b, double Aexion){
	double iR = recip(length2(*xz,*yz,*zz)); iR = -iR;
	//z *= -iR;
	*xz *= iR; *yz *= iR; *zz *= iR;
	*xz = -b - *xz; *yz = a + *yz; *zz = Aexion - *zz; 
	*DF *= -iR;//max(1.,iR);
}

void TransAInv_Aex(double* xz, double* yz, double* zz, double* DF, double a, double b, double Aexion){
	double iR;
	*xz = +b + *xz; *yz = a - *yz;  
	*zz = -Aexion + *zz; // ? wut
	iR = recip(length2(*xz,*yz,*zz));
	*xz *= iR; *yz *= iR; *zz *= iR;
	*DF *= iR;//max(1.,iR);
}
