// ***********************************************************************
// **** C version of Kleinian script by Luca GN @ fractalforums, ***
// **** transcript of (see under) ***
// ***********************************************************************
#include "utility_MATH.cpp" // include this always 1st
#include "utility_DIFS.cpp"

void wrap3D(double* x0, double* y0, double* z0,
double xa, double ya, double za,
double xs, double ys, double zs);

void wrap2D(double* x0, double* y0,
double xa, double ya,
double xs, double ys);

void TransA(double* xz, double* yz, double* zz, double* DF, double a, double b);
void TransAInv(double* xz, double* yz, double* zz, double* DF, double a, double b);

/*
// ***********************************************************************
// **** Original fragmentarium script by Jos & Knighty begins here: ***
// ***********************************************************************
#group Kleinian_test
uniform int Box_Iterations;  slider[1,50,100]
//Trace of the transformation a
uniform float KleinR;  slider[1.8,2.0,2.0]
uniform float KleinI;  slider[-0.2,0.0,0.2]
//To really give a kleinian group they must be of the form cos(PI/n) if <1 and any value if >=1
uniform float box_size_z;  slider[0.0,0.5,1.0]
uniform float box_size_x;  slider[0.0,0.5,1.0]
//WIP: Help get better DE?
uniform int Final_Iterations;  slider[0,5,20]
//Want do show the balls
uniform bool ShowBalls; checkbox[true]
//4 generators or 3? apply y translation
uniform bool FourGen; checkbox[false]
//The DE is wilde. It needs some clamping
uniform float Clamp_y;  slider[0.01,1.0,10.0]
uniform float Clamp_DF;    slider[0.0,1.0,10.0]

#group SphInv

//Want do do an inversion
uniform bool DoInversion; checkbox[false]
//Inversion center
uniform vec3 InvCenter; slider[(-1,-1,-1),(0,0,0),(1,1,1)]
//Inversion radius squared
uniform float InvRadius;  slider[0.01,1,2]
//Recenter
uniform vec3 ReCenter; slider[(-5,-5,-5),(0,0,0),(5,5,5)]

float dot2(vec3 z){ return dot(z,z);}

vec3 wrap(vec3 x, vec3 a, vec3 s){
	x -= s; 
	return (x-a*floor(x/a)) + s;
}

vec2 wrap(vec2 x, vec2 a, vec2 s){
	x -= s; 
	return (x-a*floor(x/a)) + s;
}

void TransA(inout vec3 z, inout float DF, float a, float b){
	float iR = 1. / dot2(z);
	z *= -iR;
	z.x = -b - z.x; z.y = a + z.y; 
	DF *= iR;//max(1.,iR);
}

void TransAInv(inout vec3 z, inout float DF, float a, float b){
	float iR = 1. / dot2(z + vec3(b,-a,0.));
	z.x += b; z.y = a - z.y; 
	z *= iR;
	DF *= iR;//max(1.,iR);
}

float  JosKleinian(vec3 z)
{
	vec3 lz=z+vec3(1.), llz=z+vec3(-1.);
	float DE=1e10;
	float DF = 1.0;
	float a = KleinR, b = KleinI;
	float f = sign(b) ;     
	for (int i = 0; i < Box_Iterations ; i++) 
	{
		//if(z.y<0. || z.y>a) break;
		
		z.x=z.x+b/a*z.y;
		if (FourGen)
			z = wrap(z, vec3(2. * box_size_x, a, 2. * box_size_z), vec3(- box_size_x, 0., - box_size_z));
		else
			z.xz = wrap(z.xz, vec2(2. * box_size_x, 2. * box_size_z), vec2(- box_size_x, - box_size_z));
		z.x=z.x-b/a*z.y;

		//If above the separation line, rotate by 180 about (-b/2, a/2)
		if  (z.y >= a * (0.5 +  f * 0.25 * sign(z.x + b * 0.5)* (1. - exp( - 3.2 * abs(z.x + b * 0.5)))))	
			z = vec3(-b, a, 0.) - z;//
			//z.xy = vec2(-b, a) - z.xy;//
		
		orbitTrap = min(orbitTrap, abs(vec4(z,dot(z,z))));//For colouring

		//Apply transformation a
		TransA(z, DF, a, b);
		
		//If the iterated points enters a 2-cycle , bail out.
		if(dot2(z-llz) < 1e-12) {
#if 0
			orbitTrap =vec4(1./float(i),0.,0.,0.);
#endif
			break;
		}
		//Store prvious iterates
		llz=lz; lz=z;
	}
	
	//WIP: Push the iterated point left or right depending on the sign of KleinI
	for (int i=0;i<Final_Iterations;i++){
		float y = ShowBalls ? min(z.y, a-z.y) : z.y;
		DE=min(DE,min(y,Clamp_y)/max(DF,Clamp_DF));
		TransA(z, DF, a, b);
	}
	float y = ShowBalls ? min(z.y, a-z.y) : z.y;
	DE=min(DE,min(y,Clamp_y)/max(DF,Clamp_DF));

	return DE;
}
*/

// ULTRASLIM since Jessie said Mb3D prepares everything for us already
// We just use those lame macros it should be fine I hope? duh
void __attribute__((fastcall)) __main(void) {
	double x,y,z;
	//vec3 lz=z+vec3(1.), llz=z+vec3(-1.);
	double DF = load1();
	x=loadX(); y=loadY(); z=loadZ();
	double lzx = x+DF; double lzy = y+DF; double lzz = z+DF;
	double llzx = x-DF; double llzy = y-DF; double llzz = z-DF;
	double DE = loadNthDoubleCns(0,0);
	double d2;
	double oC = DE;
	double a, b;
	//double bdiva = (fabs(b)>loadNthDoubleCns(1,0))?b/a:load1();
	double bdiva;
	double f; // f * 0.25
	int Box_Iterations = loadNthIntVar(0,6*szof1dbl);
	int Final_Iterations = loadNthIntVar(1,6*szof1dbl);
	int MiscOps;
	int SpI = (loadNthIntVar(2,6*szof1dbl))&4;
	double bsx = loadNthDoubleVar(2,0);
	double bsz = loadNthDoubleVar(3,0);
	double bsx2 = bsx*loadNthDoubleCns(5,0);
	double bsz2 = bsz*loadNthDoubleCns(5,0);
	int i;

	if (Box_Iterations>100) Box_Iterations = 100;
	if (Final_Iterations>20) Final_Iterations = 20;

    //Box_Iterations = 30; Final_Iterations = 4;
    a = loadNthDoubleVar(0,0); b = loadNthDoubleVar(1,0);
    bdiva = (b/a);
	WORD oldcw=fegr_floor(); // wrap() works ok
	f = sign(b)*loadNthDoubleCns(3,0); // f * 0.25
	
	// vars:
	// 0 = dbl a; 1 = dbl b; 2 = dbl box_size_x; 3 = dbl box_size_y; 
	// 4 = dbl clampY; 5 = dbl clampDF; 
	// 6+off(3int) = iCx 7+off(3int) = iCx 8+off(3int) = iCx
	// 0+off(6dbl) = int Box_Iterations; 
	// 1+off(6dbl) = int Final_Iterations; 
	MiscOps = (loadNthIntVar(2,6*szof1dbl))&4;
    if (MiscOps) {
        //z=z-InvCenter;
        x = x - loadNthDoubleVar(6,3*szof1int);
        y = y - loadNthDoubleVar(7,3*szof1int);
        z = z - loadNthDoubleVar(8,3*szof1int);
		double iR = loadNthDoubleVar(9,3*szof1int); iR *= iR;
		d2 = length2(x,y,z);
		iR = iR/d2;
		x = x*iR + loadNthDoubleVar(6,3*szof1int);
        y = y*iR + loadNthDoubleVar(7,3*szof1int);
        z = z*iR + loadNthDoubleVar(8,3*szof1int);
    }
    
	MiscOps = (loadNthIntVar(2,6*szof1dbl))&1;
	for (i = 0; i < Box_Iterations ; i++) 
	{
		//if(z.y<0. || z.y>a) break;
		
		x += bdiva*y;
		/*
		if (FourGen)
			z = wrap(z, vec3(2. * box_size_x, a, 2. * box_size_z), vec3(- box_size_x, 0., - box_size_z));
		else
			z.xz = wrap(z.xz, vec2(2. * box_size_x, 2. * box_size_z), vec2(- box_size_x, - box_size_z));
		*/
	if (MiscOps) {
		wrap3D(&x,&y,&z,
				bsx2,a,	bsz2,
				-bsx,loadzero(),-bsz); 
	} else {
		wrap2D(&x,&z,
				bsx2,bsz2,
				-bsx,-bsz);
	}	
		x -= bdiva*y;

		//If above the separation line, rotate by 180 about (-b/2, a/2)
		// if  (z.y >= a * (0.5 +  f * 0.25 * sign(z.x + b * 0.5)* (1. - exp( - 3.2 * abs(z.x + b * 0.5)))))
		{
			double x00 = x + b * loadNthDoubleCns(2,0);
			x00 = loadNthDoubleCns(2,0) +  f * sign(x00) *
			 (load1() - exp( loadNthDoubleCns(4,0) * fabs(x00) ) ) ;
			if  (y >= a *x00 ) 
			{
				//z = vec3(-b, a, 0.) - z;
				x = -b - x; y = a - y; z = -z;
				//z.xy = vec2(-b, a) - z.xy; // commented out...........
			}	
		}

		//Apply transformation a
		TransA(&x,&y,&z, &DF, a, b);
		
		/*
			//For colouring
			double oCn = fabs(fabs(y)-fabs(x)-fabs(z));
			oC = min(oC, oCn);
		*/

		
		//If the iterated points enters a 2-cycle , bail out.
		if ( length2(x-llzx,y-llzy,z-llzz) < loadNthDoubleCns(1,0) ) 
		{
			break;
		}
		//Store prvious iterates
		llzx = lzx; llzy = lzy; llzz = lzz;
		lzx = x; lzy = y; lzz = z;
	}
	
	saveOTColor(lzy/(i+1));
	bsx = loadNthDoubleVar(4,0); // clampy
	bsz = loadNthDoubleVar(5,0); // clampdf
	MiscOps = (loadNthIntVar(2,6*szof1dbl))&2;
	MiscOps = (MiscOps != 0);
	//WIP: Push the iterated point left or right depending on the sign of KleinI
	i = 0;
	// sorry for using GOTO but it just does its job perfectly here
	do {
	    if (MiscOps) donothing();
			else y = min(y, a-y); // Show balls (Strongly reccomended! Really! :D )
		DE=min(DE,min(y,bsx)/max(DF,bsz));
		if (i>=Final_Iterations) break;
		TransAInv(&x,&y,&z, &DF, a, b);
		i++;
	} while (1);
	
	MiscOps = (loadNthIntVar(2,6*szof1dbl))&4;
    if (MiscOps) {
        DE=DE*d2/(loadNthDoubleVar(9,3*szof1int)+sqrt(d2)*DE);
    }
    
	fesetround(oldcw); // do this right before returning
	saveDE (DE);
/*
cns; loadNthDoubleCns(n,0);

0 = 1e10
1 = 1e-5
2 = 0.5
3 = 0.25
4 = -3.2
5 = 2.
---------
*/
}

// all forced inline because the compiler likes to mess up

INLI2 void wrap3D(double* x0, double* y0, double* z0,
double xa, double ya, double za,
double xs, double ys, double zs)
{
	// x -= s; 
	*x0 -= xs; *y0 -= ys; *z0 -= zs;
	// return (x-a*floor(x/a)) + s;
	*x0 += xs-xa*storeint(*x0/xa);
	*y0 += ys-ya*storeint(*y0/ya);
	*z0 += zs-za*storeint(*z0/za);
}

INLI2 void wrap2D(double* x0, double* y0,
double xa, double ya,
double xs, double ys)
{
	// x -= s; 
	*x0 -= xs; *y0 -= ys;
	// return (x-a*floor(x/a)) + s;
	*x0 += xs-xa*storeint(*x0/xa);
	*y0 += ys-ya*storeint(*y0/ya);
}

/* 
void TransA(inout vec3 z, inout float DF, float a, float b){
	float iR = 1. / dot2(z);
	z *= -iR;
	z.x = -b - z.x; z.y = a + z.y; 
	DF *= iR;//max(1.,iR);
}*/

INLI2 void TransA(double* xz, double* yz, double* zz, double* DF, double a, double b){
	double iR = recip(length2(*xz,*yz,*zz)); iR = -iR;
	//z *= -iR;
	*xz *= iR; *yz *= iR; *zz *= iR;
	*xz = -b - *xz; *yz = a + *yz; 
	*DF *= -iR;//max(1.,iR);
}

/* void TransAInv(inout vec3 z, inout float DF, float a, float b){
	float iR = 1. / dot2(z + vec3(b,-a,0.));
	z.x += b; z.y = a - z.y; 
	z *= iR;
	DF *= iR;//max(1.,iR);
} */

INLI2 void TransAInv(double* xz, double* yz, double* zz, double* DF, double a, double b){
	double iR;
	*xz = +b + *xz; *yz = a - *yz; 
	iR = recip(length2(*xz,*yz,*zz));
	*xz *= iR; *yz *= iR; *zz *= iR;

	*DF *= iR;//max(1.,iR);
}
