// #include <math.h>
#include <_mingw.h>
// #include <fenv.h>
#define INLI2 __MINGW_INTRIN_INLINE // unlike the normal inline (compiler may disrespect it) , this ENSURES inlining and we need it
#define S0RRY asm volatile          // shortcut

typedef unsigned short  WORD; // 2bytes
const int szof1int = 4; // helps to find out offsets
const int szof1dbl = 8; // helps to find out offsets

// MATH
INLI2 const double __cdecl loadzero (void);
INLI2 const double __cdecl load1 (void);
INLI2 int __cdecl storeint (double _x);
INLI2 WORD __cdecl fegr_floor ();
INLI2 WORD __cdecl fegr_ceil ();
INLI2 WORD __cdecl fegr_round ();
INLI2 void __cdecl fesetround (WORD ocw);
INLI2 double __cdecl Hypot(double x,double y);
INLI2 double __cdecl Mag(double x,double y);
INLI2 double __cdecl length2(double x,double y,double z);
INLI2 double __cdecl length(double x,double y,double z);
INLI2 double __cdecl recip (double _x);
INLI2 double __cdecl sign (double _x);
INLI2 double __cdecl sqrt (double _x);
INLI2 double __cdecl exp (double _x);
INLI2 double __cdecl log (double _x);
INLI2 double __cdecl atan2 (double _x,double _y);
INLI2 double __cdecl pow (double _base,double _expon);
INLI2 void __cdecl sinandcos (double _ang, double* _sinang, double* _cosang);
INLI2 double __cdecl max (double _a, double _b);
INLI2 double __cdecl max3 (double _a, double _b, double _c);
INLI2 double __cdecl min (double _a, double _b);
INLI2 double __cdecl min3 (double _a, double _b, double _c);
INLI2 double __cdecl fabs (double x);
INLI2 int __cdecl istep (double edge, double _x);
INLI2 double __cdecl length0(double x,double y,double z);
INLI2 double smin(double a,double b,double k);
INLI2 double __cdecl intpow (double _x, int P);

INLI2 void __cdecl donothing (void) // lol
{
  S0RRY ("fnop");
}

INLI2 const double __cdecl loadzero (void) // uses constants, assembly required :o)
{
  double res;
  S0RRY ("fldz": "=t" (res));
  return res;
}

INLI2 const double __cdecl load1 (void) // uses constants, assembly required :o)
{
  double res;
  S0RRY ("fld1": "=t" (res));
  return res;
}

INLI2 int __cdecl storeint (double _x) // (int) or round, ceil, floor with zero overhead; needs cw setting to get sthg useful
{
  int res;
  __asm__ ("fldl %1\n\t"
        "fistpl %0\n\t"
        :"=m"(res) // out MEMORY
        :"m"(_x)   // in MEMORY
        // (nothing clobbered) :P
        );
  return res;
}

INLI2 WORD __cdecl fegr_floor () // rounding mode to correct value
{
  WORD ncw;
  WORD ocw;
  __asm__ ("fstcw %0\n\t"
        "mov %0, %%ax\n\t"
        // "or $0x0C,%%ah\n\t" // FE_TOWARDZERO -> round()
        "and $0xF3,%%ah\n\t" // reset rounding mode
        "or $0x04,%%ah\n\t" // FE_DOWNWARD -> floor()
        "mov %%ax,%1\n\t"
        "fldcw %1\n\t"
        :"=m"(ocw),"=m"(ncw) // out MEMORY
        :   // in nothing
        :"%eax"    // modify EAX (clobbered)
        );
  return ocw;
}

INLI2 WORD __cdecl fegr_ceil () // rounding mode to correct value
{
  WORD ncw;
  WORD ocw;
  __asm__ ("fstcw %0\n\t"
        "mov %0, %%ax\n\t"
        // "or $0x0C,%%ah\n\t" // FE_TOWARDZERO -> round()
        "and $0xF3,%%ah\n\t" // reset rounding mode
        "or $0x08,%%ah\n\t" // FE_DOWNWARD -> ceil()
        "mov %%ax,%1\n\t"
        "fldcw %1\n\t"
        :"=m"(ocw),"=m"(ncw) // out MEMORY
        :   // in nothing
        :"%eax"    // modify EAX (clobbered)
        );
  return ocw;
}

INLI2 WORD __cdecl fegr_round () // rounding mode to correct value
{
  WORD ncw;
  WORD ocw;
  __asm__ ("fstcw %0\n\t"
        "mov %0, %%ax\n\t"
        "or $0x0C,%%ah\n\t" // FE_TOWARDZERO -> round()
        "mov %%ax,%1\n\t"
        "fldcw %1\n\t"
        :"=m"(ocw),"=m"(ncw) // out MEMORY
        :   // in nothing
        :"%eax"    // modify EAX (clobbered)
        );
  return ocw;
}

INLI2 void __cdecl fesetround (WORD ocw) // rounding mode reset
{
  __asm__ ("fldcw %0\n\t"
        :// out nothing
        :"m"(ocw) // in MEMORY   
        );
  return;
}

INLI2 double __cdecl Hypot(double x,double y) { return sqrt(x*x+y*y); }

INLI2 double __cdecl Mag(double x,double y) { return (x*x+y*y); }

INLI2 double __cdecl length2(double x,double y,double z) { return (x*x+y*y+z*z); }

INLI2 double __cdecl length(double x,double y,double z) { return sqrt(length2(x,y,z)); }

INLI2 double __cdecl recip (double _x) // uses constants, assembly required :o)
{
  double res;
  S0RRY ("fld1\n\t"
	    "fdivp": "=t" (res) : "0" (_x));
  return res;
}

INLI2 double __cdecl sign (double _x) // thanks http://www.website.masmforum.com/
{ // sign(0)=0 else +1 or -1
  double res;
  __asm__ ("ftst\n\t"
	    "fstsw %%ax\n\t"
        "sahf\n\t"
        "jb _caseneg%=\n\t"
        "ja _casepos%=\n\t"
        "fldz\n\t"
        "jmp _sgend%=\n\t"
        "_casepos%=:\n\t"
        "fld1\n\t"
        "jmp _sgend%=\n\t"
        "_caseneg%=:\n\t"
        "fld1\n\t"
        "fchs\n\t"
        "_sgend%=:\n\t"
        "fstp %%st(1)"
        :"=t"(res) // out
        :"0"(_x)   // in
        :"%eax"    // modify EAX (clobbered)
        );
  return res;
}

INLI2 double __cdecl sqrt (double _x) // uses constants, assembly required :o)
{
  double res;
  S0RRY ("fsqrt\n\t": "=t" (res) : "0" (_x));
  return res;
}

INLI2 double __cdecl exp (double _x) // uses constants, assembly required :o)
{
  double res;
  S0RRY ("fldl2e\n\t"
  		"fmulp\n\t"
  		"fld1\n\t"
  		"fld %%st(1)\n\t" 
  		"fprem\n\t"
  		"f2xm1\n\t"
  		"faddp\n\t"
  		"fscale\n\t"
  		"fxch\n\t"
  		"fstp %%st\n\t"
  : "=t" (res) : "0" (_x));
  return res;
}

INLI2 double __cdecl log (double _x) // uses constants, assembly required :o)
{
  double res;
  S0RRY ("fldln2\n\t"
  		"fxch\n\t"
  		"fyl2x\n\t"
  : "=t" (res) : "0" (_x));
  return res;
}

INLI2 double __cdecl atan2 (double _x,double _y) 
{
  double res;
  S0RRY ("fpatan\n\t"
  : "=t" (res) : "0" (_x), "u" (_y):
   "%st(1)" ); // IT CLOBBERS ST1!!!!!!! TELL THIS TO COMPILER!
  return res;
}

INLI2 double __cdecl pow (double _base,double _expon) 
{
  return exp(_expon*log(_base));
}

INLI2 void __cdecl sinandcos (double _ang, double* _sinang, double* _cosang) 
{
    S0RRY ("fldl %2\n\t"
         "fsincos\n\t"
         "fstpl %1\n\t"
         "fstpl %0\n\t" : "=m"(*_sinang), "=m"(*_cosang) : "m"(_ang));
}

INLI2 double __cdecl max (double _a, double _b)
{
  return (_a>_b)?_a:_b;
}

INLI2 double __cdecl max3 (double _a, double _b, double _c)
{
  return max(max(_a,_b),_c);
}

INLI2 double __cdecl min (double _a, double _b)
{
  return (_a<_b)?_a:_b;
}

INLI2 double __cdecl min3 (double _a, double _b, double _c)
{
  return min(min(_a,_b),_c);
}

// math.h copyp
INLI2 double __cdecl fabs (double x)
{
	double res;
	asm volatile  ("fabs\n\t" : "=t" (res) : "0" (x));
	return res;
}

INLI2 int __cdecl istep (double edge, double _x)
{
  return ((_x<=edge)?0:1); // cleaner and fancy
}

INLI2 double __cdecl length0(double x,double y,double z) { double zzz=loadzero(); return sqrt(length2(max(x, zzz),max(y, zzz),max(z, zzz))); }

INLI2 double smin(double a,double b,double k) { //from iq adapted :P DO NOT!!! do -log
	double ka = -k*a; double kb = -k*b;
	return log(exp(ka)+exp(kb))/(-k);
} 

INLI2 double __cdecl intpow (double _x, int P)
{
    double result = 1., base = _x;
    register int exp = P;
    if (exp <0) {
            base = recip(base);
            exp = -exp;
    } 
    if (exp >10) { // safety
            return base;
    }
    /*   from stackoverflow.com (Elias Yarrkov)
    tweaked */
    
    while (exp)
    {
        if (exp & 1)
            result *= base;
        exp >>= 1;
        base *= base;
    }
    return result;
}

